## hackrf 2026.01.3

=== docs/requirements.txt ===
sphinx==7.2.6
sphinx_rtd_theme==2.0.0
readthedocs-sphinx-search==0.3.2
jinja2==3.1.6
