=== debian/changelog ===
hackrf (2026.01.3-1) unstable; urgency=medium

  * New upstream release. (Closes: #1127759)
  * Use Picolibc!
  * Update Standards-Version (no changes)
  * update watch file
  * update man pages

 -- A. Maitland Bottoms <bottoms@debian.org>  Mon, 16 Feb 2026 15:59:43 -0500
