=== debian/watch ===
Version: 5

Source: https://github.com/greatscottgadgets//hackrf/tags
Matching-Pattern: (?:.*?/)?v?(\d[\d.]*)\.tar\.gz
Filenamemangle: s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%@PACKAGE@-$1.tar.gz%
Update-Script: uupdate

Component: firmware-libopencm3
Source: https://github.com/mossmann/libopencm3.git
Matching-Pattern: HEAD
Mode: git
Pgpmode: none
Version-Schema: ignore
